package sort;
public class HeapSort extends AbstractSort {

	public void go() {
		for (int i = n / 2; i >= 0; i--)
			percDown(i, n);
		for (int i = n - 1; i > 0; i--) {
			swap(0, i);
			percDown(0, i);
		}
	}

	/**
	 * Internal method for heapsort that is used in
	 * deleteMax and buildHeap.
	 * @param a an array of Comparable items.
	 * @index i the position from which to percolate down.
	 * @int n the logical size of the binary heap.
	 */
	private void percDown(int i, int n) {
		int child, tmp;
		for (tmp = A[i]; 2 * i + 1 < n; i = child) {
			child = 2 * i + 1;
			if (child != n - 1 && A[child] < A[child + 1]) child++;
			if (tmp < A[child]) A[i] = A[child];
			else break;
		}
		A[i] = tmp;
	}

}
